<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\DataWarga;
use App\Models\Dpt;
use App\Models\Kabupaten;
use App\Models\Kelurahan;
use App\Models\Kecamatan;
use App\Models\SuratDukungan;
use App\User;
use Auth;
use Barryvdh\DomPDF\Facade as PDF;
use DateTime;
use Illuminate\Support\Facades\DB;

class RekapController extends Controller
{

    public function rekap($menu)
    {
        // ini_set('memory_limit', '44M');
    	switch ($menu) {
    		case 'data-warga-periode':
                $title = "Rekap Data Warga Per Periode";
                $link = "rekap/data-warga-periode";
                $paren = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
    			if(isset($_GET['rekap'])){
                    $datas = DataWarga::orderBy('created_at','DESC');
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('created_at','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('created_at','<=',date('Y-m-d',strtotime($periode[1])));
                        $subtitle = "Periode : ".$periode[0]." - ".$periode[1];

                    }

                    if(isset($_GET['user_id']) && $_GET['user_id'] != null && $_GET['user_id'] != ''){
                        $datas = $datas->where('user_id',$_GET['user_id']);
                    }


                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                    $q->where('nama_kecamatan','like','%'.$s.'%')->orWhereHas('kabupatens', function ($e) use($s) {
                                        $e->where('nama_kabupaten','like','%'.$s.'%');
                                    });
                                });
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }

                    $filename = "data-warga-periode.xls";

                    $pdf = PDF::loadView('rekap.excel', compact('title','link','datas','no','filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-warga-periode-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','filename'));
                    // return view('rekap.excel',compact('title','link','datas','no','filename'));


                } else {


                    $datas = DataWarga::orderBy('created_at','DESC');
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('created_at','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('created_at','<=',date('Y-m-d',strtotime($periode[1])));

                    }

                    if(isset($_GET['user_id']) && $_GET['user_id'] != null && $_GET['user_id'] != ''){
                        $datas = $datas->where('user_id',$_GET['user_id']);
                    }

                    if(isset($_GET['kelurahan_id']) && $_GET['kelurahan_id'] != null && $_GET['kelurahan_id'] != ''){
                        $datas = $datas->where('kelurahan_id',$_GET['kelurahan_id']);
                    }

                    if(isset($_GET['kecamatan_id']) && $_GET['kecamatan_id'] != null && $_GET['kecamatan_id'] != ''){
                        $ki = $_GET['kecamatan_id'];
                        $datas = $datas->whereHas('kelurahan',function ($q) use($ki)
                        {
                            $q->where('kecamatan_id',$ki);
                        });
                    }

                    $kelurahans = Kelurahan::orderBy('nama_kelurahan','asc')->pluck('nama_kelurahan','id');
                    $kecamatans = Kecamatan::orderBy('nama_kecamatan','asc')->pluck('nama_kecamatan','id');
                    $users = User::orderBy('name','asc')->pluck('name','id');

                    $no = 1*$page*10-10+1;

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                    $q->where('nama_kecamatan','like','%'.$s.'%')->orWhereHas('kabupatens', function ($e) use($s) {
                                        $e->where('nama_kabupaten','like','%'.$s.'%');
                                    });
                                });
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }

                    $formCari = 'layouts.include.rekap-periode';
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','kelurahans','kecamatans','users','formCari'));

                }
                break;
            case 'data-warga-pengguna':
                $title = "Rekap Data Warga Per Pengguna";
                $link = "rekap/data-warga-pengguna";
                $paren = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
                if(isset($_GET['rekap'])){
                    $datas = DataWarga::orderBy('created_at','DESC');

                    $usr = "";
                    if(isset($_GET['user_id']) && $_GET['user_id'] != null && $_GET['user_id'] != ''){
                        $datas = $datas->where('user_id',$_GET['user_id']);
                        $usr = User::find($_GET['user_id']);
                        $subtitle = "Pengguna : ".$usr->name;
                    }

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                $q->where('nama_kecamatan','like','%'.$s.'%')->orWhereHas('kabupatens', function ($e) use($s) {
                                    $e->where('nama_kabupaten','like','%'.$s.'%');
                                });
                            });
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }

                    // dd($usr);
                    $filename = "data-warga-pengguna.xls";
                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','filename'));


                    $pdf = PDF::loadView('rekap.excel', compact('title','link','datas','usr','no','filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-warga-pengguna-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','link','datas','usr','no','filename'));





                } else {


                    $datas = DataWarga::orderBy('created_at','DESC');


                    if(isset($_GET['user_id']) && $_GET['user_id'] != null && $_GET['user_id'] != ''){
                        $datas = $datas->where('user_id',$_GET['user_id']);
                    }

                    if(isset($_GET['periode'])) {
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('created_at','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('created_at','<=',date('Y-m-d',strtotime($periode[1])));
                    }



                    $kelurahans = Kelurahan::orderBy('nama_kelurahan','asc')->pluck('nama_kelurahan','id');
                    $kecamatans = Kecamatan::orderBy('nama_kecamatan','asc')->pluck('nama_kecamatan','id');
                    $users = User::orderBy('name','asc')->pluck('name','id');

                    $no = 1*$page*10-10+1;

                    // $s = str_replace('+','', $s);
                    // dd($s);

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                $q->where('nama_kecamatan','like','%'.$s.'%')->orWhereHas('kabupatens', function ($e) use($s) {
                                    $e->where('nama_kabupaten','like','%'.$s.'%');
                                });
                            });
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }

                    $formCari = "layouts.include.rekap-per-pengguna";
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','kelurahans','kecamatans','users','formCari'));

                    break;
                }
                break;

            case 'data-warga-kelurahan':
                $title = "Rekap Data Warga Per Kelurahan";
                $link = "rekap/data-warga-kelurahan";
                $paren = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
                if(isset($_GET['rekap'])){
                    $datas = DataWarga::orderBy('created_at','DESC');


                    $kel = "";
                    if(isset($_GET['kelurahan_id']) && $_GET['kelurahan_id'] != null && $_GET['kelurahan_id'] != ''){
                        $kel = Kelurahan::find($_GET['kelurahan_id']);
                        $subtitle = "Kelurahan : ".$kel->nama_kelurahan." - Kecamatan : ".$kel->kecamatan->nama_kecamatan;
                        $datas = $datas->where('kelurahan_id',$_GET['kelurahan_id']);
                    }


                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere('nik','like','%'.$s.'%')->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }
                    $filename = "data-warga-kelurahan.xls";

                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','filename','subtitle'));

                    $pdf = PDF::loadView('rekap.excel', compact('title','kel','link','datas','no','filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-warga-kelurahan-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','kel','link','datas','no','filename'));





                } else {


                    $datas = DataWarga::orderBy('created_at','DESC');


                    if(isset($_GET['kelurahan_id']) && $_GET['kelurahan_id'] != null && $_GET['kelurahan_id'] != ''){
                        $datas = $datas->where('kelurahan_id',$_GET['kelurahan_id']);
                    }



                    $kelurahans = Kelurahan::orderBy('nama_kelurahan','asc')->pluck('nama_kelurahan','id');
                    $kecamatans = Kecamatan::orderBy('nama_kecamatan','asc')->pluck('nama_kecamatan','id');
                    $users = User::orderBy('name','asc')->pluck('name','id');

                    $no = 1*$page*10-10+1;

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere('nik','like','%'.$s.'%')->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }
                    $formCari = "layouts.include.rekap-per-kelurahan";
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','kelurahans','kecamatans','users','formCari'));

                    break;
                }
                break;

            case 'data-warga-kecamatan':
                $title = "Rekap Data Warga Per Kecamatan";
                $link = "rekap/data-warga-kecamatan";
                $parent = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
                if(isset($_GET['rekap'])){
                    $datas = DataWarga::orderBy('created_at','DESC');

                    $kec = "";
                    if(isset($_GET['kecamatan_id']) && $_GET['kecamatan_id'] != null && $_GET['kecamatan_id'] != ''){
                        $ki = $_GET['kecamatan_id'];
                        $kec = Kecamatan::find($_GET['kecamatan_id']);
                        $subtitle = "Kecamatan : ".$kec->nama_kecamatan;
                        $datas = $datas->whereHas('kelurahan',function ($q) use($ki)
                        {
                            $q->where('kecamatan_id',$ki);
                        });
                    }

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%');
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }

                    $filename = "data-warga-kecamatan.xls";
                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','subtitle'));

                    $pdf = PDF::loadView('rekap.excel', compact('title','parent','kec','link','datas','no', 'filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-warga-kecamatan-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','parent','kec','link','datas','no', 'filename'));





                } else {


                    $datas = DataWarga::orderBy('created_at','DESC');


                    if(isset($_GET['kecamatan_id']) && $_GET['kecamatan_id'] != null && $_GET['kecamatan_id'] != ''){
                        $ki = $_GET['kecamatan_id'];
                        $datas = $datas->whereHas('kelurahan',function ($q) use($ki)
                        {
                            $q->where('kecamatan_id',$ki);
                        });
                    }



                    $kelurahans = Kelurahan::orderBy('nama_kelurahan','asc')->pluck('nama_kelurahan','id');
                    $kecamatans = Kecamatan::orderBy('nama_kecamatan','asc')->pluck('nama_kecamatan','id');
                    $users = User::orderBy('name','asc')->pluck('name','id');

                    $no = 1*$page*10-10+1;

                    if($s != "") {
                        $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                        {
                            $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                $q->where('nama_kelurahan','like','%'.$s.'%');
                            });
                        })->paginate(400);
                    } else {
                        $datas = $datas->paginate(400);
                    }
                    $formCari = "layouts.include.rekap-per-kecamatan";
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','kelurahans','kecamatans','users','formCari'));

                    break;
                }
                break;
                case 'data-warga-kabupaten':
                    $title = "Rekap Data Warga Per Kabupaten";
                    $link = "rekap/data-warga-kabupaten";
                    $parent = "Rekap";
                    $s = '';
                    $page = 1;
                    $no = 1;
                    if(isset($_GET['s'])){
                        $s = $_GET['s'];
                    }

                    if(isset($_GET['page'])){
                        $page = $_GET['page'];
                    }
                    if(isset($_GET['rekap'])){
                        $datas = DataWarga::orderBy('created_at','DESC');

                        $kec = "";
                        if(isset($_GET['kabupaten_id']) && $_GET['kabupaten_id'] != null && $_GET['kabupaten_id'] != ''){
                            $ki = $_GET['kabupaten_id'];
                            $kec = Kabupaten::find($_GET['kabupaten_id']);
                            $subtitle = "Kabupaten : ".$kec->nama_kabupaten;
                            $datas = $datas->whereHas('kelurahan',function ($q) use($ki)
                            {
                                $q->whereHas('kecamatan', function($s) use($ki) {
                                    $s->where('kabupaten_id', $ki);
                                });
                            });
                        }


                        if($s != "") {
                            $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                            {
                                $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                    $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                        $q->where('nama_kecamatan','like','%'.$s.'%');
                                    });
                                });
                            })->paginate(400);
                        } else {
                            $datas = $datas->paginate(400);
                        }
                        $filename = "data-warga-kabupaten.xls";
                        // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','subtitle'));

                        $pdf = PDF::loadView('rekap.excel', compact('title','parent','link','datas','kec','no','filename'))->setPaper('A4', 'landscape');

                        $timezone = new \DateTimeZone('Asia/Makassar');
                        $date = new DateTime();
                        $date->setTimeZone($timezone);

                        // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                        return $pdf->download('data-warga-kabupaten-'.$date->format('d/m/Y H:i:s').'.pdf');

                        // return view('rekap.excel',compact('title','parent','link','datas','kec','no','subtitle','filename'));

                    } else {


                        $datas = DataWarga::orderBy('created_at','DESC');
                        if(isset($_GET['kabupaten_id']) && $_GET['kabupaten_id'] != null && $_GET['kabupaten_id'] != ''){
                            // dd("TEST");
                            $ki = $_GET['kabupaten_id'];
                            $datas = $datas->whereHas('kelurahan',function ($q) use($ki)
                            {
                                $q->whereHas('kecamatan', function($keca) use($ki) {
                                    $keca->where('kabupaten_id', $ki);
                                });
                            });
                        }

                        $kelurahans = Kelurahan::orderBy('nama_kelurahan','asc')->pluck('nama_kelurahan','id');
                        $kecamatans = Kecamatan::orderBy('nama_kecamatan','asc')->pluck('nama_kecamatan','id');
                        $kabupatens = Kabupaten::orderBy('nama_kabupaten','asc')->pluck('nama_kabupaten','id');
                        $users = User::orderBy('name','asc')->pluck('name','id');

                        $no = 1*$page*10-10+1;

                        if($s != "") {
                            $datas = $datas->where('nama_lengkap','like','%'.$s.'%')->orWhere(function ($a)use($s)
                            {
                                $a->orWhere('nik','like','%'.$s.'%')->orWhere('alamat','like','%'.$s.'%')->orWhereHas('kelurahan',function ($q)use($s){
                                    $q->where('nama_kelurahan','like','%'.$s.'%')->orWhereHas('kecamatan',function ($q)use($s){
                                        $q->where('nama_kecamatan','like','%'.$s.'%');
                                    });
                                });
                            })->paginate(400);
                        } else {
                            $datas = $datas->paginate(400);
                        }

                        $formCari = "layouts.include.rekap-per-kabupaten";
                        // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                        return view('rekap.table',compact('title','link','datas','no','kelurahans','kecamatans','kabupatens','users','formCari'));

                        break;
                    }
                    break;
            case 'jumlah-inputan-pengguna':
                $title = "Rekap Jumlah Inputan Pengguna";
                $link = "rekap/jumlah-inputan-pengguna";
                $parent = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
                if(isset($_GET['rekap'])){
                    $datas = User::withCount('data_wargas');
                    // dd($datas);
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereHas('data_wargas', function($da) use ($periode) {
                            $da->whereDate('created_at','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('created_at','<=',date('Y-m-d',strtotime($periode[1])));
                        })->get();

                    } else {
                        $datas = $datas->get();
                    }
                    $filename = "data-warga-kabupaten.xls";
                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','subtitle'));

                    $pdf = PDF::loadView('rekap.excel', compact('title','link','datas','no','filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-jumlah-inputan-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','parent','link','datas','kec','no','subtitle','filename'));

                } else {

                    $datas = User::select('users.id','users.name', 'users.role', DB::raw('count(data_wargas.id) as total'))
                            ->join('data_wargas', 'data_wargas.user_id','=','users.id')
                            ->groupBy('users.id');
                    // $datas = User::withCount('data_wargas');
                    // dd($datas);
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('data_wargas.created_at','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('data_wargas.created_at','<=',date('Y-m-d',strtotime($periode[1])))->get();
                        // $datas = $datas->whereHas('data_wargas', function($da) use ($periode) {

                        // })->get();

                    } else {
                        $datas = $datas->get();
                    }
                    // dd($datas);


                    $no = 1*$page*10-10+1;

                    $formCari = "layouts.include.rekap-periode";
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','formCari'));

                    break;
                }
                break;
            case 'jumlah-surat-dukungan':
                $title = "Rekap Jumlah Surat Dukungan";
                $link = "rekap/jumlah-surat-dukungan";
                $parent = "Rekap";
                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }


                if(isset($_GET['rekap'])){
                    $datas = SuratDukungan::orderBy('tanggal','DESC');
                    // $datas = User::withCount('data_wargas');
                    // dd($datas);
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('tanggal','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('tanggal','<=',date('Y-m-d',strtotime($periode[1])))->get();
                        // $datas = $datas->whereHas('data_wargas', function($da) use ($periode) {

                        // })->get();

                    } else {
                        $datas = $datas->get();
                    }
                    // dd($datas);

                    // dd($datas);
                    $filename = "jumlah-surat-dukungan.xls";
                    // return view('rekap.excel',compact('title','data-warga','parent','link','datas','no','subtitle'));

                    $pdf = PDF::loadView('rekap.inputanPDF', compact('title','link','datas','no','filename'))->setPaper('A4', 'landscape');

                    $timezone = new \DateTimeZone('Asia/Makassar');
                    $date = new DateTime();
                    $date->setTimeZone($timezone);

                    // return $pdf->stream("dompdf_out.pdf", array("Attachment" => false));
                    return $pdf->download('data-surat-dukungan-'.$date->format('d/m/Y H:i:s').'.pdf');

                    // return view('rekap.excel',compact('title','parent','link','datas','kec','no','subtitle','filename'));

                } else {

                    $datas = SuratDukungan::orderBy('tanggal','DESC');
                    // $datas = User::withCount('data_wargas');
                    // dd($datas);
                    if(isset($_GET['periode']) && $_GET['periode'] != null && $_GET['periode'] != ''){
                        $periode = explode(' - ', $_GET['periode']);
                        $datas = $datas->whereDate('tanggal','>=',date('Y-m-d',strtotime($periode[0])))->whereDate('tanggal','<=',date('Y-m-d',strtotime($periode[1])))->get();
                        // $datas = $datas->whereHas('data_wargas', function($da) use ($periode) {

                        // })->get();

                    } else {
                        $datas = $datas->get();
                    }
                    // dd($datas);


                    $no = 1*$page*10-10+1;

                    $formCari = "layouts.include.rekap-periode";
                    // return view('rekap.table',compact('title','data-warga','parent','link','datas','no','kelurahans','kecamatans','users','formCari'));
                    return view('rekap.table',compact('title','link','datas','no','formCari'));

                    break;
                }

                break;
    		case 'pengguna':
                $title = "Rekap Pengguna";
                $link = "rekap/pengguna";

                $s = '';
                $page = 1;
                $no = 1;
                if(isset($_GET['s'])){
                    $s = $_GET['s'];
                }

                if(isset($_GET['page'])){
                    $page = $_GET['page'];
                }
                if(isset($_GET['rekap'])){
                    $datas = User::where('name','like','%'.$s.'%')->orWhere('email','like','%'.$s.'%')->orderBy('created_at','DESC')->get();
                    return view('rekap.pengguna-excel',compact('title','user','parent','link','datas','no'));
                }
                else {
                    $datas = User::where('name','like','%'.$s.'%')->orWhere('email','like','%'.$s.'%')->orderBy('created_at','DESC')->paginate(10);
                    $datas->appends($_GET);
                    $no = 1*$page*10-10+1;
                    return view('rekap.pengguna',compact('title','user','parent','link','datas','no'));
                }






                break;
    		default:
    			return redirect('home');
    			break;
    	}
    }
}
